//
//  SMTSettingsRefreshTimeViewController.m
//  iSomaDemo
//
//  Created by Aman Shaikh on 28/05/14.
//  Copyright (c) 2014 Smaato Inc. All rights reserved.
//

#import "SMTSettingsRefreshTimeViewController.h"
#import "SMTAppDelegate.h"
#import <iSoma/iSoma.h>

@import QuartzCore;

@interface SMTSettingsRefreshTimeViewController ()
@property(nonatomic, weak) IBOutlet UIButton* btnMinus;
@property(nonatomic, weak) IBOutlet UIButton* btnPlus;
@property(nonatomic, weak) IBOutlet UILabel* lblInterval;
@end

@implementation SMTSettingsRefreshTimeViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad{
    [super viewDidLoad];
	
	self.btnPlus.enabled = [iSoma autoReloadInterval] <180;
	self.btnMinus.enabled = [iSoma autoReloadInterval] >30;
	
	[self updateIntervalText];
	
	self.btnMinus.layer.cornerRadius = self.btnMinus.frame.size.width/2;
	self.btnPlus.layer.cornerRadius = self.btnPlus.frame.size.width/2;
}

- (void) updateIntervalText{
	int interval = [iSoma autoReloadInterval];
	if (interval == 0) {
		interval = 30;
	}
	self.lblInterval.text = [NSString stringWithFormat:@"%d seconds", interval];
}

- (void)viewWillAppear:(BOOL)animated{
	[super viewWillAppear:animated];
	[(SMTAppDelegate*)[UIApplication sharedApplication].delegate hideLeftEdge];
}

- (void) viewWillDisappear:(BOOL)animated{
	[super viewWillDisappear:animated];
	[(SMTAppDelegate*)[UIApplication sharedApplication].delegate showLeftEdge];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)onMinus:(id)sender{
	int currentValue = [iSoma autoReloadInterval];
	currentValue-=10;
	
	if (currentValue > 30) {
		self.btnPlus.enabled = YES;
	} else {
		currentValue=30;
		self.btnMinus.enabled = NO;
	}
	
	[iSoma setAutoReloadInterval:currentValue];
	
	[self updateIntervalText];
}
- (IBAction)onPlus:(id)sender{
	int currentValue = [iSoma autoReloadInterval];
	currentValue+=10;
	
	if (currentValue < 180) {
		self.btnMinus.enabled = YES;
	} else {
		currentValue=180;
		self.btnPlus.enabled = NO;
	}
	
	[iSoma setAutoReloadInterval:currentValue];
	[self updateIntervalText];
}

@end
